/* Copyright (c) 2008-09 lvqcl.  All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2.1 of the License, or (at
 * your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */ 

#ifndef FOODSPLPF_H
#define FOODSPLPF_H

#include "../foobar2000/SDK/foobar2000.h"
#include "rate/lowpass.h"
#include "dsp_lpf_config.h"

class dsp_lowpass : public dsp_impl_base
{
	lpfConfig cfg_;

	audio_sample* buffer_;

	size_t in_samples_accum_, out_samples_gen_accum_;

	unsigned sample_rate_;
	unsigned channel_count_;
	unsigned buf_channels_;

	LPF_handle* lpf_state_;

	void init();

	bool set_data(const dsp_preset & p_data);
 
public:
	dsp_lowpass();
	dsp_lowpass(const dsp_preset& params);
	~dsp_lowpass();

	static void g_get_name(pfc::string_base & p_out) { p_out.set_string("Lowpass (SoX)"); }
	static bool g_get_default_preset(dsp_preset & p_out);
	static GUID g_get_guid() { return t_dsp_lpf_params::g_get_guid(); }
	static bool g_have_config_popup() { return true; }
	static void g_show_config_popup(const dsp_preset & p_data,HWND p_parent, dsp_preset_edit_callback & p_callback);

	virtual void flush();
	virtual double get_latency();
	virtual bool need_track_change_mark() { return false; }
	virtual void on_endoftrack(abort_callback & p_abort);
	virtual void on_endofplayback(abort_callback & p_abort);
	virtual bool on_chunk(audio_chunk * chunk, abort_callback & p_abort);

protected:
	void reinit(unsigned sample_rate, unsigned channel_count);
	void flushwrite();
};

#endif
