#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <intrin.h>
#include "rate/lowpass.h"
#include "rate/fft4g.h"

BOOL WINAPI DllMain(HINSTANCE hinstDll, DWORD fdwReason, LPVOID lpvReserved)
{
	if (fdwReason == DLL_PROCESS_ATTACH)
	{
		int info[4];
		__cpuid(info, 1);

		if (info[2] & 1) /* SSE3 */
		{
			lsx_rdft = lsx_rdft_SSE3;
			lpf_init0_SSE3();
		}
		else
		{
			lsx_rdft = lsx_rdft_generic;
			lpf_init0_generic();
		}
	}
	return TRUE;
}

void (*lsx_rdft)(int, int, double *, int *, double *);

LPF_handle* (*LPF_init)(const LPF_config* config, int nchannels, int *error); /*create+start*/
LPF_handle* (*LPF_close)(LPF_handle *h); /*stop*/
int (*LPF_flow)(LPF_handle *h, const fb_sample_t* ibuf, fb_sample_t* obuf, size_t isamp, size_t osamp, size_t* iused, size_t* ogen); /*flow*/
int (*LPF_drain)(LPF_handle *h, fb_sample_t* obuf, size_t osamp, size_t* ogen); /*drain*/
